#include "xmmsPlayback.h"
#include "xmmsUtils.h"
#include "xmmsResultWrapper.h"

NS_IMPL_ISUPPORTS1(xmmsPlayback, xmmsIPlayback)

xmmsPlayback::xmmsPlayback(const Xmms::Playback& playback)
 : mPlayback(playback)
{
  /* member initializers and constructor code */
}

xmmsPlayback::~xmmsPlayback()
{
  /* destructor code */
}

/* void play (in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsPlayback::Play(xmmsIResult *cb, xmmsIError *e)
{
    XMMS_TRY
    Xmms::VoidResult r = mPlayback.start();
    //mPlayback.start();
    new xmmsVoidResultWrapper(r, cb, e);
    // TODO track? and free wrapper
    return NS_OK;
    XMMS_CATCH
}

/* void pause (in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsPlayback::Pause(xmmsIResult *cb, xmmsIError *e)
{
    XMMS_TRY
    mPlayback.pause();
    return NS_OK;
    XMMS_CATCH
}

/* void stop (in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsPlayback::Stop(xmmsIResult *cb, xmmsIError *e)
{
    XMMS_TRY
    mPlayback.stop();
    return NS_OK;
    XMMS_CATCH
}

/* void next (in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsPlayback::Next(xmmsIResult *cb, xmmsIError *e)
{
    XMMS_TRY
    mPlayback.tickle();
    return NS_OK;
    XMMS_CATCH
}

/* void seekAbs (in long pos, in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsPlayback::SeekAbs(PRInt32 pos, xmmsIResult *cb, xmmsIError *e)
{
    XMMS_TRY
    mPlayback.seekMs(pos);
    return NS_OK;
    XMMS_CATCH
}

/* void seekRel (in long posRel, in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsPlayback::SeekRel(PRInt32 posRel, xmmsIResult *cb, xmmsIError *e)
{
    XMMS_TRY
    mPlayback.seekMsRel(posRel);
    return NS_OK;
    XMMS_CATCH
}

/* void currentSong (in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsPlayback::CurrentSong(xmmsIResult *cb, xmmsIError *e)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addSongObserver (in xmmsIObserver o); */
NS_IMETHODIMP xmmsPlayback::AddSongObserver(xmmsIObserver *o)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeSongObserver (in xmmsIObserver o); */
NS_IMETHODIMP xmmsPlayback::RemoveSongObserver(xmmsIObserver *o)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void currentPlaytime (in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsPlayback::CurrentPlaytime(xmmsIResult *cb, xmmsIError *e)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addPlaytimeObserver (in xmmsIObserver o, in long intervall); */
NS_IMETHODIMP xmmsPlayback::AddPlaytimeObserver(xmmsIObserver *o, PRInt32 intervall)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removePlaytimeObserver (in xmmsIObserver o); */
NS_IMETHODIMP xmmsPlayback::RemovePlaytimeObserver(xmmsIObserver *o)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getVolume (in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsPlayback::GetVolume(xmmsIResult *cb, xmmsIError *e)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setVolume (in long newVal, in xmmsIResult cb, in xmmsIError e); */
NS_IMETHODIMP xmmsPlayback::SetVolume(PRInt32 newVal, xmmsIResult *cb, xmmsIError *e)
{
    XMMS_TRY
    mPlayback.volumeSet("MASTER", newVal);
    // TODO channel configurable
    return NS_OK;
    XMMS_CATCH
}

/* void addVolumeObserver (in xmmsIObserver o); */
NS_IMETHODIMP xmmsPlayback::AddVolumeObserver(xmmsIObserver *o)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeVolumeObserver (in xmmsIObserver o); */
NS_IMETHODIMP xmmsPlayback::RemoveVolumeObserver(xmmsIObserver *o)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
